///////////////////////////
//Weapon class for gestures
///////////////////////////

class grabinGestureGun extends Weapon
    config(user);

#EXEC OBJ LOAD FILE=InterfaceContent.utx

var(FirstPerson) float NewEffectOffset;

simulated function vector GetEffectStart()
{
    local Vector X,Y,Z;

    if ( Instigator.IsFirstPerson() && (Hand == 0) )
    {
        GetViewAxes(X, Y, Z);
        if ( class'PlayerController'.Default.bSmallWeapons || Level.bClassicView )
            return (Instigator.Location +
                Instigator.CalcDrawOffset(self) +
                SmallEffectOffset.X * X  +
                SmallEffectOffset.Y * Y * Hand -
                NewEffectOffset * Z);
        else
            return (Instigator.Location +
                Instigator.CalcDrawOffset(self) +
                EffectOffset.X * X +
                EffectOffset.Y * Y * Hand +
                EffectOffset.Z * Z);
    }
    return Super.GetEffectStart();
}

simulated function Destroyed()
{
    Super.Destroyed();
}

simulated function bool HasAmmo()
{
    return true;
}

simulated function bool ConsumeAmmo(int mode, float load, optional bool bAmountNeededIsMax)
{
    return true;
}

defaultproperties
{
     NewEffectOffset=5.000000
     FireModeClass(0)=grabin.blankFire
     FireModeClass(1)=grabin.blankFire
     PutDownAnim="PutDown"
     IdleAnimRate=0.030000
     AIRating=0.990000
     CurrentRating=0.990000
     bCanThrow=False
     EffectOffset=(X=100.000000,Y=25.000000,Z=-3.000000)
     Priority=3
     HudColor=(B=128,R=128)
     SmallViewOffset=(X=10.000000,Y=4.000000,Z=-9.000000)
     CenteredOffsetY=-12.000000
     CenteredRoll=3000
     CenteredYaw=-300
     CustomCrosshair=7
     CustomCrossHairTextureName="Crosshairs.HUD.Crosshair_Cross1"
     InventoryGroup=2
     PickupClass=grabin.grabinGGPickup
     PlayerViewOffset=(X=-2.000000,Y=-2.000000,Z=-3.000000)
     PlayerViewPivot=(Yaw=500)
     BobDamping=1.575000
     AttachmentClass=grabin.grabinGGAttach
     ItemName="Gesture Gun"
     UV2Texture=Shader'XGameShaders.WeaponShaders.WeaponEnvShader'
}
