//=============================================================================
// s_Melee
// this is used when we can not use the more enhanced form of melee
// (3rd persons/custom anim) so that our ChaosUT mut will remian compatible.
//
// $Id: s_Melee.uc,v 1.2 2003/10/06 21:15:58 jb Exp $
//=============================================================================
class s_Melee extends Weapon abstract;

// The Purpose of this class is allow for better blocking effects for a melee

var sound BlockSound[7];  // set to 7 possible block sounds
var float blockrange;    // this is the effective area the weapon can block hits on




function AdjustPlayerDamage( out int Damage, Pawn InstigatedBy, Vector HitLocation,
						         out Vector Momentum, class<DamageType> DamageType)
{

  	local vector Reflect;
    local vector HitNormal;

    if(InstigatedBy == Instigator)
        return;  // Hmmm can not block your own hit.

    if ( CheckBlock(HitLocation, HitNormal, 0) )
    {                     // here imples that we did indeed block the shoot
	    Reflect = MirrorVectorByNormal( Normal(Location - HitLocation), Vector(Instigator.Rotation) );
        Damage = 0;        // take no damage
        Momentum *= 15.0;
        PlaySound(BlockSound[Rand(7)], SLOT_None);      // play block sound
        //WeaponAttachment(Weapon.ThirdPersonActor).UpdateHit(Other,HitLocation,HitNormal);  // spawn block effects
        Spawn(class'xHeavyWallHitEffect',,,HitLocation,rotator(HitNormal));
        // note add the feature to look at the instigators weapon or the damage type
        // and play a different block sound based of that...
        StopFire(1);      // now we need to stop the player from blocking
        Instigator.Controller.bAltFire = 0;
    }
}


function bool CheckBlock( Vector HitLocation, out Vector RefNormal, int AmmoDrain )
{
    local Vector HitDir;
    local Vector FaceDir;

    if (!FireMode[1].bIsFiring) return false;

    FaceDir = Vector(Instigator.Controller.Rotation);
    HitDir = Normal(Instigator.Location - HitLocation + Vect(0,0,8));
    RefNormal = FaceDir;
    if ( FaceDir dot HitDir < blockrange ) // 68 degree protection arc = -37.5 use cos to find other angls
    {
        return true;
    }
    return false;
}

defaultproperties
{
}
